{******************************************************************

                       JEDI-VCL Demo

 Copyright (C) 2002 Project JEDI

 Original author:

 Contributor(s):

 You may retrieve the latest version of this file at the JEDI-JVCL
 home page, located at http://jvcl.sourceforge.net

 The contents of this file are used with permission, subject to
 the Mozilla Public License Version 1.1 (the "License"); you may
 not use this file except in compliance with the License. You may
 obtain a copy of the License at
 http://www.mozilla.org/MPL/MPL-1_1Final.html

 Software distributed under the License is distributed on an
 "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 implied. See the License for the specific language governing
 rights and limitations under the License.

******************************************************************}
{

Last Modified: 3 September 2005 by Alexey V. Nikitayev

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:
}

unit JvNTEventLogMainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, JvNTEventLog, JvComponent,
  ocNetwork, LM, JvTrayIcon, DateUtils;

type
  TDeviceErrors = record
    Disk: Cardinal;
    Ntfs: Cardinal;
    PCI: Cardinal;
    Processor: Cardinal;
  end;
  TSystemEvents = record
    TotalEvents:Cardinal;
    TotalErrors:Cardinal;
    LastWeekErrors:Cardinal;
    LastDayErrors:Cardinal;
    TotalDeviceErrors:TDeviceErrors;
    LastWeekDeviceErrors:TDeviceErrors;
    LastDayDeviceErrors:TDeviceErrors;
  end;
  TApplicationEvents = record
    TotalEvents:Cardinal;
    TotalErrors:Cardinal;
    LastWeekErrors:Cardinal;
    LastDayErrors:Cardinal;
  end;
  TSecurityEvents = record
    TotalEvents:Cardinal;
    TotalErrors:Cardinal;
    LastWeekErrors:Cardinal;
    LastDayErrors:Cardinal;
  end;
  TServerResult = record
    Errors, TotalMessages: Cardinal;
    System:TSystemEvents;
    Application:TApplicationEvents;
    Security:TSecurityEvents;
  end;
  
  TJvNTEventLogMainForm = class(TForm)
    Panel2: TPanel;
    Button1: TButton;
    StaticText1: TStaticText;
    TabSheet3: TTabSheet;
    Panel3: TPanel;
    Button2: TButton;
    TimeReport: TMemo;
    JvTrayIcon1: TJvTrayIcon;
    procedure cbServersMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure cbServersKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
  published
    JvNTEventLog1: TJvNTEventLog;
    Panel1: TPanel;
    Memo1: TMemo;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ButtonsPanel: TPanel;
    btnRefresh: TButton;
    cbServers: TComboBox;
    ListView1: TListView;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    QuickAnalyzeReport: TMemo;
    procedure ListBox1Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure cbServersChange(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
  private
    { Private declarations }
    procedure ReadEvents;
    function GetServerProblemsCount(const Server:string;
      var SR:TServerResult):boolean;
    procedure EnumNetworkTimes(var MinDate, MaxDate:TDateTime);
  end;

var
  JvNTEventLogMainForm: TJvNTEventLogMainForm;

implementation

{$R *.dfm}

procedure TJvNTEventLogMainForm.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex > -1 then
  begin
    JvNTEventLog1.Active := false;
    JvNTEventLog1.Log := ListBox1.Items[ListBox1.ItemIndex];
    JvNTEventLog1.Source := ListBox1.Items[ListBox1.ItemIndex];
    JvNTEventLog1.Active := True;
    ReadEvents;
  end;
end;

procedure TJvNTEventLogMainForm.ReadEvents;
var
  item: TListItem;
begin
  if (JvNTEventLog1.Source='') then exit;
  ListView1.Items.BeginUpdate;
  Screen.Cursor := crHourGlass;
  try
    ListView1.Items.Clear;

    JvNTEventLog1.First;
    while not JvNTEventLog1.Eof do
    begin
      item := ListView1.Items.Add;

      item.Caption := JvNTEventLog1.EventRecord.EventType;
      item.SubItems.Add(DateToStr(JvNTEventLog1.EventRecord.DateTime));
      item.SubItems.Add(TimeToStr(JvNTEventLog1.EventRecord.DateTime));
      item.SubItems.Add(JvNTEventLog1.EventRecord.Source);
      item.SubItems.Add(IntToStr(JvNTEventLog1.EventRecord.Category));
      item.SubItems.Add(IntToStr(JvNTEventLog1.EventRecord.ID and $0FFFFFFF));
      item.SubItems.Add(JvNTEventLog1.EventRecord.Username);
      item.SubItems.Add(JvNTEventLog1.EventRecord.Computer);
      JvNTEventLog1.Next;
    end;
  finally
    ListView1.Items.EndUpdate;
    Screen.Cursor := crDefault;
  end;
end;

procedure TJvNTEventLogMainForm.ListView1Click(Sender: TObject);
begin
  JvNTEventLog1.Seek(ListView1.Selected.Index);
  Memo1.Lines.Clear;
  Memo1.Lines.Add(JvNTEventLog1.EventRecord.MessageText);
  
end;

procedure TJvNTEventLogMainForm.FormShow(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;

  try
    PageControl1.ActivePageIndex:=0;
    Memo1.Lines.Clear;
    ocNetwork.EnumNetwork(0,cbServers.Items,nil);
    if cbServers.Items.Count>0 then
    begin
      cbServers.Text:=cbServers.Items[0];
      JvNTEventLog1.Server:=cbServers.Text;
      JvNTEventLog1.ReadEventLogs(ListBox1.Items);
      ListBox1.Selected[0]:=true;
      JvNTEventLog1.Source := ListBox1.Items[0];
      JvNTEventLog1.Active := True;
    end;
  except
  end;
  Screen.Cursor:=crDefault;
end;

procedure TJvNTEventLogMainForm.btnRefreshClick(Sender: TObject);
var
  PrevServer:string;
begin
  PrevServer:=cbServers.Text;
  ocNetwork.EnumNetwork(0,cbServers.Items,nil);
  if (cbServers.Items.IndexOf(PrevServer)=-1) then
  begin
    if cbServers.Items.Count>0 then
      cbServers.Text:=cbServers.Items[0];
    JvNTEventLog1.Server:=cbServers.Text;
    JvNTEventLog1.Active:=true;
    ReadEvents;
  end;
end;

procedure TJvNTEventLogMainForm.cbServersChange(Sender: TObject);
begin
  JvNTEventLog1.Server:=cbServers.Text;
  JvNTEventLog1.Active:=true;
  ReadEvents;
end;

procedure TJvNTEventLogMainForm.TabSheet2Show(Sender: TObject);
var
  i:Integer;
  SR:TServerResult;
begin
  Screen.Cursor:=crHourGlass;
  QuickAnalyzeReport.Lines.Clear;

  try
    for i:=0 to cbServers.Items.Count-1 do
    begin
      if GetServerProblemsCount(cbServers.Items[i], SR) then
      begin
        QuickAnalyzeReport.Lines.Add(
          Format(
            '%s'#9'Total messages:'#9'%d',
            [cbServers.Items[i],SR.TotalMessages])
          );
        QuickAnalyzeReport.Lines.Add(
          Format('Errors:'#9'%d'#9'Last week errors:'#9'%d'#9'Last day errors:'#9'%d',
            [SR.Errors,
             SR.System.LastWeekErrors+SR.Application.LastWeekErrors+SR.Security.LastWeekErrors,
             SR.System.LastDayErrors+SR.Application.LastDayErrors+SR.Security.LastDayErrors]));

        QuickAnalyzeReport.Lines.Add(
          Format(#9'System events     '#9'Count:'#9'%d',[SR.System.TotalEvents]));
        QuickAnalyzeReport.Lines.Add(
          Format(#9'  Total errors:'#9'%d'#9'Last week errors:'#9'%d'#9'Last day errors:'#9'%d',
            [SR.System.TotalErrors,
             SR.System.LastWeekErrors,
             SR.System.LastDayErrors]));

        QuickAnalyzeReport.Lines.Add(
          Format(#9'Application events'#9'Count:'#9'%d',[SR.Application.TotalEvents]));
        QuickAnalyzeReport.Lines.Add(
          Format(#9'  Total errors:'#9'%d'#9'Last week errors:'#9'%d'#9'Last day errors:'#9'%d',
            [SR.Application.TotalErrors,
             SR.Application.LastWeekErrors,
             SR.Application.LastDayErrors]));

        if (SR.Security.TotalEvents>0) then
        begin
          QuickAnalyzeReport.Lines.Add(
            Format(#9'Security events   '#9'Count:'#9'%d',[SR.Security.TotalEvents]));
          QuickAnalyzeReport.Lines.Add(
            Format(#9'  Total errors:'#9'%d'#9'Last week errors:'#9'%d'#9'Last day errors:'#9'%d',
              [SR.Security.TotalErrors,
               SR.Security.LastWeekErrors,
               SR.Security.LastDayErrors]));
        end else
        begin
          QuickAnalyzeReport.Lines.Add(#9'Security policy is not configured!   <----------');
        end;

        if (SR.System.TotalDeviceErrors.Disk+
            SR.System.TotalDeviceErrors.Ntfs+
            SR.System.TotalDeviceErrors.PCI+
            SR.System.TotalDeviceErrors.Processor>0) then
        begin
          QuickAnalyzeReport.Lines.Add(
            Format(#9'Hardware errors'#9'Count:'#9'%d  <----------',[
              SR.System.TotalDeviceErrors.Disk+
              SR.System.TotalDeviceErrors.Ntfs+
              SR.System.TotalDeviceErrors.PCI+
              SR.System.TotalDeviceErrors.Processor]));
          QuickAnalyzeReport.Lines.Add(
            Format(#9'  HDD:'#9'%d'#9'NTFS:'#9'%d'#9'PCI:'#9'%d'#9'Processor:'#9'%d'#9,[
              SR.System.TotalDeviceErrors.Disk,
              SR.System.TotalDeviceErrors.Ntfs,
              SR.System.TotalDeviceErrors.PCI,
              SR.System.TotalDeviceErrors.Processor]));
          QuickAnalyzeReport.Lines.Add(#9'  Last week hardware errors');
          QuickAnalyzeReport.Lines.Add(
            Format(#9'  HDD:'#9'%d'#9'NTFS:'#9'%d'#9'PCI:'#9'%d'#9'Processor:'#9'%d'#9,[
              SR.System.LastWeekDeviceErrors.Disk,
              SR.System.LastWeekDeviceErrors.Ntfs,
              SR.System.LastWeekDeviceErrors.PCI,
              SR.System.LastWeekDeviceErrors.Processor]));
          QuickAnalyzeReport.Lines.Add(#9'  Last day hardware errors');
          QuickAnalyzeReport.Lines.Add(
            Format(#9'  HDD:'#9'%d'#9'NTFS:'#9'%d'#9'PCI:'#9'%d'#9'Processor:'#9'%d'#9,[
              SR.System.LastDayDeviceErrors.Disk,
              SR.System.LastDayDeviceErrors.Ntfs,
              SR.System.LastDayDeviceErrors.PCI,
              SR.System.LastDayDeviceErrors.Processor]));
          Beep;
        end
        else
        begin
          QuickAnalyzeReport.Lines.Add(#9'No critical hardware errors');
        end;
        QuickAnalyzeReport.Lines.Add('');
        Sleep(100);
      end
      else
      QuickAnalyzeReport.Lines.Add(
        Format('Computer %s is not WinNT or access denied.',[cbServers.Items[i]])
        );
    end;

  except
  end;
  Screen.Cursor:=crDefault;
end;

function TJvNTEventLogMainForm.GetServerProblemsCount(
  const Server: string;
  var SR:TServerResult): boolean;
var
  SL:TStringList;
  i:Integer;
  LastWeek,LastDay:TDateTime;
  
  procedure AddSystemEvent (const Event:TJvNTEventLogRecord);
    procedure IncDiskError;
    begin
      Inc(SR.System.TotalDeviceErrors.Disk);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.System.LastDayDeviceErrors.Disk);
        Inc(SR.System.LastWeekDeviceErrors.Disk);
      end;
    end;
    procedure IncNtfsError;
    begin
      Inc(SR.System.TotalDeviceErrors.Ntfs);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.System.LastDayDeviceErrors.Ntfs);
        Inc(SR.System.LastWeekDeviceErrors.Ntfs);
      end;
    end;
    procedure IncPciError;
    begin
      Inc(SR.System.TotalDeviceErrors.Pci);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.System.LastDayDeviceErrors.Pci);
        Inc(SR.System.LastWeekDeviceErrors.Pci);
      end;
    end;
    procedure IncProcessorError;
    begin
      Inc(SR.System.TotalDeviceErrors.Processor);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.System.LastDayDeviceErrors.Processor);
        Inc(SR.System.LastWeekDeviceErrors.Processor);
      end;
    end;
  begin
    Inc(SR.System.TotalEvents);
    if (JvNTEventLog1.EventRecord.EventType='Error') or 
       (JvNTEventLog1.EventRecord.EventType='Warning')
       then
    begin
      Inc(SR.Errors);
      Inc(SR.System.TotalErrors);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.System.LastDayErrors);
        Inc(SR.System.LastWeekErrors);
      end;
      if (JvNTEventLog1.EventRecord.Source='disk') then IncDiskError
      else
      if (JvNTEventLog1.EventRecord.Source='ntfs') then IncNtfsError
      else
      if (JvNTEventLog1.EventRecord.Source='pci') then IncPciError
      else
      if (JvNTEventLog1.EventRecord.Source='Processor') then IncProcessorError;
    end
  end;
  procedure AddApplicationEvent (const Event:TJvNTEventLogRecord);
  begin
    Inc(SR.Application.TotalEvents);
    if (JvNTEventLog1.EventRecord.EventType='Error') then
    begin
      Inc(SR.Errors);
      Inc(SR.Application.TotalErrors);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.Application.LastDayErrors);
        Inc(SR.Application.LastWeekErrors);
      end;
    end;
  end;
  procedure AddSecurityEvent (const Event:TJvNTEventLogRecord);
  begin
    Inc(SR.Security.TotalEvents);
    if (JvNTEventLog1.EventRecord.EventType='Error') then
    begin
      Inc(SR.Errors);
      Inc(SR.Security.TotalErrors);
      if (Event.DateTime>LastWeek) then
      begin
        if (Event.DateTime>LastDay) then Inc(SR.Security.LastDayErrors);
        Inc(SR.Security.LastWeekErrors);
      end;
    end;
  end;

var
  JournalIndex:byte; // 0:system, 1:application, 2:security
begin
  result:=false;
  try
    FillChar(SR,SizeOf(SR),0);
    LastDay:=Yesterday;
    LastWeek:=Date-7;
    SL:=TStringList.Create;
    
    JvNTEventLog1.Active:=False;
    JvNTEventLog1.Server:=Server;
    JvNTEventLog1.Active:=true;
    JvNTEventLog1.ReadEventLogs(SL);

    JournalIndex:=10;
    for i:=0 to SL.Count-1 do
    begin

      JvNTEventLog1.Source:=SL[i];
      if (JvNTEventLog1.Source='System') then JournalIndex:=0
      else if (JvNTEventLog1.Source='Application') then JournalIndex:=1
      else if (JvNTEventLog1.Source='Security') then JournalIndex:=2
      else continue;

      JvNTEventLog1.First;
      while not JvNTEventLog1.Eof do
      begin
        case JournalIndex of
          0:AddSystemEvent(JvNTEventLog1.EventRecord);
          1:AddApplicationEvent(JvNTEventLog1.EventRecord);
          2:AddSecurityEvent(JvNTEventLog1.EventRecord);
        end;
        inc(SR.TotalMessages);
        JvNTEventLog1.Next;
      end;
      if (i mod 100 = 0) then Sleep(50);
    end;
    result:=true;
  except
  end;
  FreeAndNil(SL);
end;

procedure TJvNTEventLogMainForm.cbServersMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  cbServersChange(nil);
end;

procedure TJvNTEventLogMainForm.cbServersKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key=#13 then cbServersChange(nil);
end;

procedure TJvNTEventLogMainForm.Button2Click(Sender: TObject);
var
  MinDate,MaxDate:TDateTime;
  MinDTS,MaxDTS:string;
begin
  Screen.Cursor:=crHourGlass;
  EnumNetworkTimes(MinDate,MaxDate);
  DateSeparator:='/';
  TimeSeparator:=':';
  DateTimeToString(MinDTS,'yyyy/mm/dd hh:mm:ss',MinDate);
  DateTimeToString(MaxDTS,'yyyy/mm/dd hh:mm:ss',MaxDate);
  TimeReport.Lines.Add(Format('Minimum:'#9'%s'#9'Maximum:'#9'%s',[MinDTS,MaxDTS]));
  if (abs(MinDate-MaxDate)>1) then
  begin
    TimeReport.Lines.Add('Critical error! <---------------------');
    Beep;
  end;
  Screen.Cursor:=crDefault;
end;

procedure TJvNTEventLogMainForm.EnumNetworkTimes(var MinDate,
  MaxDate: TDateTime);
var
  i:Integer;
  info:PTimeOfDayInfo;
  buff: array [0..511] of WideChar;
  PWC:PWideChar;
  CurrTime: TDateTime;
  lpSystemTime: TSystemTime;
  DeltaTime:TDateTime;
begin
  TimeReport.Lines.Clear;
  try
    GetSystemTime(lpSystemTime);
    MinDate:=EncodeDateTime(
          lpSystemTime.wYear,lpSystemTime.wMonth,lpSystemTime.wDay,
          lpSystemTime.wHour,lpSystemTime.wMinute,lpSystemTime.wSecond,lpSystemTime.wMilliseconds);
    GetLocalTime(lpSystemTime);
    DeltaTime:=EncodeDateTime(
          lpSystemTime.wYear,lpSystemTime.wMonth,lpSystemTime.wDay,
          lpSystemTime.wHour,lpSystemTime.wMinute,lpSystemTime.wSecond,lpSystemTime.wMilliseconds)-
          MinDate;
    MinDate:=MinDate+DeltaTime;
    MaxDate:=MinDate;
    for i:=0 to cbServers.Items.Count-1 do
    begin
      PWC:=StringToWideChar(cbServers.Items[i],buff,SizeOf(buff));
      info:=nil;
      if (NetRemoteTOD(PWC,@info)=NERR_Success) and (info<>nil) then
      begin
        CurrTime:=EncodeDateTime(
          info.tod_year,info.tod_month,info.tod_day,
          info.tod_hours,info.tod_mins,info.tod_secs,0)+DeltaTime;
        
        if (MinDate>CurrTime) then MinDate:=CurrTime
        else if (MaxDate<CurrTime) then MaxDate:=CurrTime;

        TimeReport.Lines.Add(
          Format(
            '%s'#9'%d/%d/%d %d:%d:%d',
            [cbServers.Items[i],
             info.tod_year,info.tod_month,info.tod_day,
             info.tod_hours,info.tod_mins,info.tod_secs])
          );
      end
      else
        QuickAnalyzeReport.Lines.Add(
          Format('Computer %s is not WinNT or higher. Or access denied.',[cbServers.Items[i]])
          );
    end;

  except
  end;
end;

end.

